#ifndef PROGRAM_RAM_HH
#define PROGRAM_RAM_HH


#include "ram.hh"

#include <vm68k/types.h>
#include <vm68k/memory.h>
#include <vm68k/processor.h>

using namespace vm68k ;



class ProgramRAM : public RAM
{
public:
    struct file_reading_exception : exception
    {
    } ;

    ProgramRAM ( uint32_type startAddr , uint32_type memorySize ,
                    const char * filename , bool debug = false ) 
            throw ( memory_exception , file_reading_exception ) ;
    virtual ~ProgramRAM () ;

    uint32_type getStartPC () 
        { return startPC ; } ;
    uint32_type getLowestAddrUsedByProgram () 
        { return lowestAddrUsed ; } ;
    uint32_type getHighestAddrUsedByProgram () 
        { return highestAddrUsed ; } ;

private:
    uint32_type startPC ;
    uint32_type lowestAddrUsed , highestAddrUsed ;
} ;


#endif

