
    led_display : entity seven_segment_driver(basic)
        port map ( clock => fast_clock ,
                    -- byte_to_output ( 4 downto 0 ) => state ,
                    -- byte_to_output ( 7 downto 5 ) => "000" ,
                    -- byte_to_output =>
                            -- data_register_2 ( 31 downto 24 ) ,
                    byte_to_output => led_display_word ( 15 downto 8 ) ,
                    blank_display => '0' ,
                    enable => '1' ,
                    led_output_pins => led_display_output ) ;

    right_led_display : entity seven_segment_driver(basic)
        port map ( clock => fast_clock ,
                    -- byte_to_output ( 7 downto 4 ) => 
                            -- call_stack_pointer ,
                    -- byte_to_output ( 3 downto 0 ) => 
                            -- data_register_2 ( 3 downto 0 ) ,
                    byte_to_output => led_display_word ( 7 downto 0 ) ,
                    blank_display => '0' ,
                    enable => '1' ,
                    led_output_pins => right_led_display_output ) ;


    led_display_mux : process ( 
            switches , operand_address , operand_value ,
            pc_register , instruction_register , 
            register_file_address_out_x , register_file_address_out_y ,
            register_file_data_out_x , register_file_data_out_y ,
            immediate_data_reg , register_file_data_out_y , 
            state , call_stack_at_ptr_minus_one ,
            call_stack_pointer , clock , 
            ea_move_destination_control , ccr , condition_true ,
            last_output , debug_memory_out ,
            operation_size ) is
    begin
        case switches ( 4 downto 0 ) is
        when "00000" =>
            led_display_word <= operand_address ( 15 downto 0 ) ;
        when "00001" =>
            led_display_word <= operand_value ( 15 downto 0 ) ;
        when "00010" =>
            led_display_word <= pc_register ( 15 downto 0 ) ;
        when "00011" => 
            led_display_word <= instruction_register ;
        when "00100" => 
            led_display_word <= register_file_address_out_x ( 15 downto 0 ) ;
        when "00101" => 
            led_display_word <= register_file_data_out_x ( 15 downto 0 ) ;
        when "00110" => 
            led_display_word <= register_file_address_out_y ( 15 downto 0 ) ;
        when "00111" => 
            led_display_word <= register_file_address_out_y ( 31 downto 16 ) ;
        when "01000" => 
            led_display_word <= register_file_data_out_y ( 15 downto 0 ) ;
        when "01001" => 
            led_display_word <= register_file_data_out_y ( 31 downto 16 ) ;
        when "01010" => 
            led_display_word <= immediate_data_reg ( 15 downto 0 ) ;
        when "01011" => 
            led_display_word <= immediate_data_reg ( 31 downto 16 ) ;
        when "01100" => 
            led_display_word ( state_register'length - 1 downto 0 ) <= state ;
            led_display_word ( 15 downto state_register'length ) <= 
                                            ( others => '0' ) ;
        when "01101" => 
            led_display_word ( state_register'length - 1 downto 0 ) <= 
                        call_stack_at_ptr_minus_one ;
            led_display_word ( 15 downto state_register'length ) <= 
                                            ( others => '0' ) ;
        when "01110" => 
            led_display_word ( stack_pointer_register'length - 1 downto 0 ) <= 
                        call_stack_pointer ;
            led_display_word ( 7 downto stack_pointer_register'length ) <= 
                                            ( others => '0' ) ;
            led_display_word ( 15 downto 8 ) <= ccr ( 7 downto 0 ) ;
        when "01111" =>
            led_display_word ( 15 downto 0 ) <= ( others => '0' ) ;

            led_display_word ( 15 ) <= condition_true ;
            led_display_word ( 14 ) <=
                        ea_move_destination_control ;

            case operation_size is
            when BYTE =>
                led_display_word ( 10 downto 8 ) <= "001" ;
            when WORD =>
                led_display_word ( 10 downto 8 ) <= "010" ;
            when others =>
                led_display_word ( 10 downto 8 ) <= "100" ;
            end case ;

            led_display_word ( 7 downto 0 ) <= last_output ;
        when others =>
            led_display_word ( 15 downto 12 ) <= switches ( 3 downto 0 ) ;
            led_display_word ( 11 downto 8 ) <= ( others => '0' ) ;
            led_display_word ( 7 downto 0 ) <= debug_memory_out ;
        end case ;
    end process ;


    light_1 <= '1' ;
    light_2 <= clock ;
    light_3 <= clock ;


