

#ifndef NDFA_TREE_H
#define NDFA_TREE_H



#include "ndfa_node.h"
#include "ndfa_accept_state.h"


class NDFA_DAG : public NDFA_Node
{
public:
    NDFA_DAG () ;
    NDFA_DAG ( Accept_State * accept_state ) ;


    void Reject_Pattern ( int start_bit , const char * pattern ) ;

    Accept_State * Get_Accept_State ( unsigned opcode ) ;
    Accept_State * Enable_Accept_State ( unsigned opcode ) ;

    void Generate_VHDL ( FILE * fd ) ;


private:
    void DFA_To_VHDL ( NDFA_Node * root_node , FILE * fd ,
                                    const char * indent ) ;


    NDFA_Node * actual_root ;
    NDFA_Node * accept_all_list [ BITS_PER_OPCODE ] ;
    bool        is_accept_all_ndfa ;
} ;




#endif

