#include <stdio.h>
#include <string.h>


#include "opcode_family.h"
#include "utils.h"


    

Opcode_Family :: Opcode_Family ( const char * micro_sub_name ) :
                                Accept_State ()
{
    this -> micro_sub_name = Copy_String ( micro_sub_name ) ;
    link = 0L ;
}

Opcode_Family :: ~Opcode_Family ()
{
    delete [] micro_sub_name ;

    Opcode_Record *             item ;
    Opcode_Record_List_Iterator iter ;

    iter = opcodes_in_family . begin () ;
    while ( iter != opcodes_in_family . end () )
    {
        item = (* iter) ;

        delete [] item -> opcode_name ;
        delete [] item -> comment ;

        iter ++ ;
    }
}

void Opcode_Family :: Print_Info ( FILE * fd , const char * old_tab_str )
{
    fprintf ( fd , "%s  microsub = %s\n" , old_tab_str , micro_sub_name ) ;

    Opcode_Record *             item ;
    Opcode_Record_List_Iterator iter ;

    iter = opcodes_in_family . begin () ;
    while ( iter != opcodes_in_family . end () )
    {
        item = (* iter) ;

        fprintf ( fd , "%s    %s (%s)\n" , old_tab_str , 
                    item -> opcode_name , item -> comment ) ;
        iter ++ ;
    }
}

void Opcode_Family :: Add_Opcode ( const char * opcode_name , 
                                    const char * comment )
{
    Opcode_Record * new_record = new Opcode_Record ;

    new_record -> opcode_name = Copy_String ( opcode_name ) ;
    new_record -> comment = Copy_String ( comment ) ;

    opcodes_in_family . insert ( opcodes_in_family . begin () , new_record ) ;
}

void Opcode_Family :: Accept_State_To_VHDL ( FILE * fd , const char * indent )
{
    assert ( link != 0L ) ;

    link -> Generate_Link_To_State_VHDL ( fd , indent ) ;
}


void Opcode_Family :: Link_Subroutine ( State_Machine * sm )
{
    assert ( sm -> Is_Finalised () ) ;

    link = sm -> Get_State_For_Name ( micro_sub_name ) ;
    if ( link == 0L )
    {
        throw new Unavailable_Microsub_Exception ( micro_sub_name ) ;
    }
}


